package ROM(AsyncROM(..), convRAMToROM) where

-- Converts the general library RAM type into an AsyncROM type,
-- which is used in some examples.

import ClientServer
import RAM
import GetPut

interface (AsyncROM :: # -> * -> * -> *) lat adr dta =
    read   :: adr -> Action
    result :: dta
    ack    :: Action

convRAMToROM :: RAM adr dta -> AsyncROM lat adr dta
convRAMToROM ram =
    interface AsyncROM
	read a = ram.request.put (Read a)
	result = peekGet ram.response
	ack    = action
		    _ <- ram.response.get
		    return ()
